var gLoriListener = null;

function registerLoriListener() {
  gLoriListener = new loriListener();
  
  const nsIWebProgress = Components.interfaces.nsIWebProgress;

  // we just need to know about notify location in the main listener to
  // allow us to figure out when a tab is activated
  const filter = (nsIWebProgress.NOTIFY_LOCATION
		  );
  // getBrowser() is from browser.js
  // this is a <tabbrowser> element
  getBrowser().addProgressListener(gLoriListener, filter);

  //var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
  //observerService.addObserver(gLoriListener, "http-on-modify-request", false);
  //observerService.addObserver(gLoriListener, "http-on-examine-response", false);  
}

function unregisterLoriListener() {
  // getBrowser() is from browser.js
  // this is a <tabbrowser> element
  getBrowser().removeProgressListener(gLoriListener);

  //var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
  //observerService.removeObserver(gLoriListener, "http-on-modify-request", false);
  //observerService.removeObserver(gLoriListener, "http-on-examine-response", false);  

  gLoriListener.destroy();
  gLoriListener = null;
}

// Notes: to iterate over list of tabs
// var l = gBrowser.mPanelContainer.childNodes.length;
// for(var i = 0; i < l; i++) {
//   var b = gBrowser.getBrowserAtIndex(i);
//   try {
//     dump(b.currentURI.spec); // dump URLs of all open tabs to console
//   } catch(e) {}
// }

function loriListener()
{
  this.init();
}

loriListener.prototype = { 
  // DEBUG
  aConsoleService: null,
  
  // Does XPConnect takes cares of
  // . nsISupports::AddRef()
  // . nsISupports::Release()
  // automatically? What about nsISupportsWeakReference?
  QueryInterface:function(aIID) {
    if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
	// aIID.equals(Components.interfaces.nsIObserver) ||
	aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
	aIID.equals(Components.interfaces.nsISupports)) {
	  return this;
	}
    throw Components.results.NS_NOINTERFACE;
  },

  // constructor
  init:function() {
    // DEBUG    
    this.logServiceInit();
    
    this.uiInit();
    
    // DEBUG
    //this.logToConsole("> topListener init");
  },

  // constructor
  destroy:function() {
    this.uiDestroy();
    
    // DEBUG
    //this.logToConsole("> topListener destroy");
    this.logServiceDestroy();
  },
  
  // menu commands
  clearMemoryCache:function() {
      //this.logToConsole("> clearMemoryCache");
      var cacheService = Components.classes["@mozilla.org/network/cache-service;1"].getService(Components.interfaces.nsICacheService);
      cacheService.evictEntries(Components.interfaces.nsICache.STORE_IN_MEMORY);
      //cacheService.evictEntries(Components.interfaces.nsICache.STORE_ON_DISK);
  },
  
  clearNetworkCache:function() {
      //this.logToConsole("> clearNetworkCache");
      var cacheService = Components.classes["@mozilla.org/network/cache-service;1"].getService(Components.interfaces.nsICacheService);
      //cacheService.evictEntries(Components.interfaces.nsICache.STORE_IN_MEMORY);
      cacheService.evictEntries(Components.interfaces.nsICache.STORE_ON_DISK);
  },
  
  clearBothCaches:function() {
      //this.logToConsole("> clearNetworkCache");
      var cacheService = Components.classes["@mozilla.org/network/cache-service;1"].getService(Components.interfaces.nsICacheService);
      cacheService.evictEntries(Components.interfaces.nsICache.STORE_IN_MEMORY);
      cacheService.evictEntries(Components.interfaces.nsICache.STORE_ON_DISK);
  },
  
  // UI 
  uiInit:function() {
    //this.loriThinkTime = document.getElementById("loriThinkTime");
    //this.loriThinkTime.collapsed = false;

    this.loriFirstXFerTime = document.getElementById("loriFirstXFerTime");
    this.loriFirstXFerTime.collapsed = false;

    this.loriElapsed = document.getElementById("loriElapsed");
    this.loriElapsed.collapsed = false;
    
    this.loriSize = document.getElementById("loriSize");
    this.loriSize.collapsed = false;
    this.loriSizeLabel = document.getElementById("loriSizeLabel");
    
    this.loriRequests = document.getElementById("loriRequests");
    this.loriRequests.collapsed = false;
  },

  bytesToString:function(nBytes) {
    var str = null;
    const KB = 1024;
    var unit = 0;
    
    //this.logToConsole("bytesToString(), nBytes=" + nBytes);
    for (unit = 0; Math.floor(nBytes / KB) > 0; unit++) {
      nBytes /= KB;
    }
    //this.logToConsole("bytesToString(), nBytes=" + nBytes + ", unit=" + unit);
    
    switch (unit) {
      case 0:
      unit = "bytes";
      break;
      
      case 1:
      unit = "KB";
      nBytes = nBytes.toFixed(2);
      break;
      
      case 2:
      unit = "MB";
      nBytes = nBytes.toFixed(2);
      break;
      
      case 3:
      unit = "GB";
      nBytes = nBytes.toFixed(2);
      break;
      
      default:
      unit = "XX";
      break;
    }
    
    str = nBytes + " " + unit;

    return str;
  },

  // XXX - How costly is new Date() vs. manual parsing?
  msToString:function(ms) {
    var d = new Date(ms);

    if (d.getMinutes() > 0) {
      str = d.getMinutes() + "m " + d.getSeconds() + "s " + d.getMilliseconds() + "ms";
    } else {
      str = d.getSeconds() + "s " + d.getMilliseconds() + "ms";
    }
    
    return str;
  },
  
  uiDisplay:function(thinkTime, firstXFerTime, elapsedTime, nBytes, dCounter, rCounter) {
    //this.loriThinkTime.label = this.msToString(thinkTime);
      
    if (firstXFerTime < 0) {
      this.loriFirstXFerTime.label = "0ms";
    } else {
      this.loriFirstXFerTime.label = this.msToString(firstXFerTime);
    }
    this.loriElapsed.label = this.msToString(elapsedTime);
    //this.loriSize.label = this.bytesToString(nBytes);
    this.loriSizeLabel.value = this.bytesToString(nBytes);
    
    //this.loriRequests.label = dCounter + " f, " + rCounter + " r";
    this.loriRequests.label = rCounter + " req";
  },
  
  uiDestroy:function() {
    //this.loriThinkTime = null;
    this.loriFirstXFerTime = null;
    this.loriElapsed = null;
    this.loriSize = null;
    this.loriSizeLabel = null;
    this.loriRequests = null;
  },

  // log service
  logServiceInit:function() {
    const nsIConsoleService = Components.interfaces.nsIConsoleService;
    var service = Components.classes["@mozilla.org/consoleservice;1"];
    this.aConsoleService = service.getService(nsIConsoleService);
  },

  logServiceDestroy:function() {
    this.aConsoleService = null;
  },
  
  logToConsole:function(aMessage) {
    if (this.aConsoleService != null) {
      this.aConsoleService.logStringMessage(new Date().getTime() + ' - lori - '+ aMessage);
    }
  },

  // nsIObserver
  /*
  observe:function(aSubject, aTopic, aData)
  {
    if (aTopic == 'http-on-modify-request') {
      aSubject.QueryInterface(Components.interfaces.nsIHttpChannel);
      this.onModifyRequest(aSubject);
    } else if (aTopic == 'http-on-examine-response') {
      aSubject.QueryInterface(Components.interfaces.nsIHttpChannel);
      this.onExamineResponse(aSubject);
    }
  },

  onModifyRequest:function(aHttp)
  {
    const nsIHttpChannel = Components.interfaces.nsIHttpChannel;

    if (aHttp.loadFlags & nsIHttpChannel.LOAD_INITIAL_DOCUMENT_URI) {
      // user triggered action (+ 3xx redirects)
      //this.logToConsole("> onModifyRequest I " + aHttp.URI.asciiSpec);
    } else {
      // stuff referenced from HTML
      //this.logToConsole("> onModifyRequest R " + aHttp.URI.asciiSpec);
    }    
  },
  
  onExamineResponse:function(aHttp)
  {
    const nsIHttpChannel = Components.interfaces.nsIHttpChannel;

    // HACK ALERT: want to do aHttp.xxx = yyy but can't.
    // So attach my data to the response header
    aHttp.setResponseHeader("X-lori-not-from-cache", "true", false);

    if (aHttp.loadFlags & nsIHttpChannel.LOAD_INITIAL_DOCUMENT_URI) {
      // user triggered action (+ 3xx redirects)
      //this.logToConsole("> onExamineResponse I " + aHttp.URI.asciiSpec);
    } else {
      // stuff referenced from HTML
      //this.logToConsole("> onExamineResponse R " + aHttp.URI.asciiSpec);
    }    
  },
  */
  
  // nsIWebProgressListener
  onStateChange:function(aWebProgress, aRequest, aStateFlags, aStatus) {
    // no-op
  },
  
  onProgressChange:function (aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {
    // no-op
  },

  // this function is triggered when a new tab is activated
  // void onLocationChange(in nsIWebProgress aWebProgress, in nsIRequest aRequest, in nsIURI aLocation);
  onLocationChange:function(aWebProgress, aRequest, aLocation) {
    var location = aLocation.spec;
    var browser = getBrowser().selectedBrowser;

    if (('loriTabListener' in browser) && (browser.loriTabListener != null)) {
      browser.loriTabListener.uiDisplay();
      //this.logToConsole("> onLocationChange U " +  location);
    } else {
      browser.loriTabListener = new loriTabListener(this);
      const nsIWebProgress = Components.interfaces.nsIWebProgress;
      const filter = (nsIWebProgress.NOTIFY_STATE_ALL |
                      nsIWebProgress.NOTIFY_PROGRESS
                      );
      browser.addProgressListener(browser.loriTabListener, filter);
      
      // call statInit(), since it is unlikely that we will see
      // STATE_START for this request
      browser.loriTabListener.statInit();
      
      //this.logToConsole("> onLocationChange N " +  location);
    }
  },
  
  // void onStatusChange(in nsIWebProgress aWebProgress, in nsIRequest aRequest, in nsresult aStatus, in wstring aMessage);
  onStatusChange:function(aWebProgress, aRequest, aStatus, aMessage) {
    // no-op
  },
  
  // void onSecurityChange(in nsIWebProgress aWebProgress, in nsIRequest aRequest, in unsigned long aState);
  onSecurityChange:function(aWebProgress, aRequest,aState) {
  }
} 

function loriTabListener(parentListener)
{
  this.init(parentListener);
}

loriTabListener.prototype = { 
  parentListener: null,

  //loriThinkTime: null,
  loriFirstXFerTime: null,
  loriElapsed: null,
  loriSize: null,
  loriSizeLabel: null,
  loriRequests: null,
  
  // track elapsed time
  startTime: null,
  thinkTime: null,
  firstXFerTime: null,		// first STATE_TRANSFERRING
  elapsedTime: null,
  endTime: null,
  
  // track number of requests
  dCounter: 0,                        /* documents */
  rCounter: 0,                        /* requests */
  
  // track size
  nBytes:0,

  QueryInterface:function(aIID) {
    if (aIID.equals(Components.interfaces.nsIWebProgressListener) ||
        aIID.equals(Components.interfaces.nsISupportsWeakReference) ||
        aIID.equals(Components.interfaces.nsISupports)) {
          return this;
        }
    throw Components.results.NS_NOINTERFACE;
  },
  
  // constructor
  init:function(parentListener) {
    this.parentListener = parentListener;

    // DEBUG
    //this.logToConsole(">> tab init");
  },

  // constructor
  destroy:function() {
    this.statDestroy();
    
    // DEBUG
    //this.logToConsole("<< tab destroy");
    this.parentListener = null;
  },

  // stat
  statInit:function() {
    // track elapsed time
    this.startTime = (new Date()).getTime();
    this.firstXFerTime = -1;
    this.elapsedTime = 0;
    if ((this.endTime == null) || (this.endTime == 0)) {
      this.thinkTime = 0;
    } else {
      this.thinkTime = (this.startTime - this.endTime);
    }
    this.endTime = this.startTime;
    
    // track number of requests
    this.dCounter = 0;
    this.rCounter = 0;
    
    // track size
    this.nBytes = 0;
  },
  
  statDestroy:function() {
    // track elapsed time
    this.startTime = null;
    this.firstXFerTime = null;
    this.elapsedTime = null;
    this.endTime = null;
    
    // track number of requests
    this.dCounter = null;
    this.rCounter = null;
    
    // track size
    this.nBytes = null;
  },

  // elapsed time
  elapsedTimeUpdate:function(now) {
    if (this.startTime == null) {
      this.elapsedTime = 0;
    } else {
      this.elapsedTime = (now - this.startTime);
    }
  },
  
  // log service
  logToConsole:function(aMessage) {
    this.parentListener.logToConsole(aMessage);
  },

  uiDisplay:function() {
    this.parentListener.uiDisplay(this.thinkTime,
				  this.firstXFerTime,
				  this.elapsedTime,
                                  this.nBytes,
                                  this.dCounter,
                                  this.rCounter);
  },

  // STATE_START
  onStateStart:function(aWebProgress, aRequest, aStateFlags, aStatus) {
    const nsIWebProgressListener = Components.interfaces.nsIWebProgressListener;
    if (aStateFlags & nsIWebProgressListener.STATE_IS_NETWORK) {
      //this.logToConsole("> onStateChange STATE_START STATE_IS_NETWORK " + aRequest.name);
      
      this.statInit();
      
      this.uiDisplay();
    }
    
    if (aStateFlags & nsIWebProgressListener.STATE_IS_WINDOW) {
      //this.logToConsole("> onStateChange STATE_START STATE_IS_WINDOW " + aRequest.name);
    }
    
    if (aStateFlags & nsIWebProgressListener.STATE_IS_DOCUMENT) {
      //this.logToConsole("> onStateChange STATE_START STATE_IS_DOCUMENT " + aRequest.name);
      this.dCounter++;
    }
    
    if (aStateFlags & nsIWebProgressListener.STATE_IS_REQUEST) {
      // ... about:layout-dummy-request
      if (aRequest.name == "about:layout-dummy-request") {
	// don't count
      }
      else {
	//this.logToConsole("> onStateChange STATE_START STATE_IS_REQUEST " + aRequest.name);
	// this is the actual count (cannot distinguish cached resources)
	this.rCounter++;
      }
    }
  },

  // PRUint32 STATE_REDIRECTING = 2
  onStateRedirecting:function(aWebProgress, aRequest, aStateFlags, aStatus) {
    const nsIWebProgressListener = Components.interfaces.nsIWebProgressListener;
    //this.logToConsole("> onStateRedirecting " + aRequest.name);
  },

  // PRUint32 STATE_TRANSFERRING = 4
  onStateTransferring:function(aWebProgress, aRequest, aStateFlags, aStatus) {
    const nsIWebProgressListener = Components.interfaces.nsIWebProgressListener;
    if (aRequest.name == "about:layout-dummy-request") {
      // ignore
    } else {
      //this.logToConsole("> onStateTransferring " + aRequest.name);
      if (this.firstXFerTime < 0) {
	if (this.startTime == null) {
	  this.firstXFerTime = 0;
	} else {
	  this.firstXFerTime = ((new Date()).getTime() - this.startTime);
	}
      }
    }
  },
  
  // PRUint32 STATE_NEGOTIATING = 8
  onStateNegotiating:function(aWebProgress, aRequest, aStateFlags, aStatus) {
    const nsIWebProgressListener = Components.interfaces.nsIWebProgressListener;
    //this.logToConsole("> onStateNegotiating " + aRequest.name);
  },
  
  // STATE_STOP
  onStateStop:function(aWebProgress, aRequest, aStateFlags, aStatus) {
    const nsIWebProgressListener = Components.interfaces.nsIWebProgressListener;
    
    if (aStateFlags & nsIWebProgressListener.STATE_IS_REQUEST) {
      // ... about:layout-dummy-request
      if (aRequest.name == "about:layout-dummy-request") {
	// don't count
      }
      else {
      }
    }
    
    if (aStateFlags & nsIWebProgressListener.STATE_IS_DOCUMENT) {
      //this.logToConsole("< onStateChange STATE_STOP STATE_IS_DOCUMENT " + aRequest.name);
    }
    
    if (aStateFlags & nsIWebProgressListener.STATE_IS_WINDOW) {
      //this.logToConsole("< onStateChange STATE_STOP STATE_IS_WINDOW " + aRequest.name);
    }
    
    if (aStateFlags & nsIWebProgressListener.STATE_IS_NETWORK) {      
      //this.logToConsole("< onStateChange STATE_STOP STATE_IS_NETWORK " + aRequest.name);

      this.endTime = new Date().getTime();
      this.elapsedTimeUpdate(this.endTime);
      
      this.uiDisplay();
    }
  },
  
  onStateChange:function(aWebProgress, aRequest, aStateFlags, aStatus) {
    const nsIWebProgressListener = Components.interfaces.nsIWebProgressListener;

    //PRUint32  LOAD_DOCUMENT_URI = 65536 
    //PRUint32  LOAD_RETARGETED_DOCUMENT_URI = 131072 
    //PRUint32  LOAD_REPLACE = 262144 
    //PRUint32  LOAD_INITIAL_DOCUMENT_URI = 524288
    /*
    const nsIChannel = Components.interfaces.nsIChannel;
    if (aRequest instanceof nsIChannel) {
      var aChannel = aRequest.QueryInterface(nsIChannel);
      if (aChannel.loadFlags & nsIChannel.LOAD_INITIAL_DOCUMENT_URI) {
	//this.logToConsole("aChannel " + aChannel.URI.spec);
      }
    }
    */
    
    // PRUint32   STATE_START  = 1
    if (aStateFlags & nsIWebProgressListener.STATE_START) {
      this.onStateStart(aWebProgress, aRequest, aStateFlags, aStatus);
    }
    
    // PRUint32 STATE_REDIRECTING = 2
    if (aStateFlags & nsIWebProgressListener.STATE_REDIRECTING) {
      this.onStateRedirecting(aWebProgress, aRequest, aStateFlags, aStatus);
    }
    
    // PRUint32 STATE_TRANSFERRING = 4
    if (aStateFlags & nsIWebProgressListener.STATE_TRANSFERRING) {
      this.onStateTransferring(aWebProgress, aRequest, aStateFlags, aStatus);
    }

    // PRUint32 STATE_NEGOTIATING = 8
    if (aStateFlags & nsIWebProgressListener.STATE_NEGOTIATING) {
      this.onStateNegotiating(aWebProgress, aRequest, aStateFlags, aStatus);
    }

    // PRUint32 STATE_STOP = 16    
    if (aStateFlags & nsIWebProgressListener.STATE_STOP) {
      this.onStateStop(aWebProgress, aRequest, aStateFlags, aStatus);
    }
  },
  
  onProgressChange:function (aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {
    this.nBytes = aCurTotalProgress;
  },
  
  onLocationChange:function(aWebProgress, aRequest, aLocation) {
    // no-op
  },
  
  onStatusChange:function(aWebProgress, aRequest, aStatus, aMessage) {
    //this.logToConsole("> onStatusChange " + aRequest.name + " " + aMessage);
  },
  
  onSecurityChange:function(aWebProgress, aRequest,aState) {
    // no-op
  }
} 

// DEBUG - enable javascript console
//toJavaScriptConsole();

// this is where thing started
window.addEventListener("load", registerLoriListener, false);
window.addEventListener("unload", unregisterLoriListener, false);
